
#ifndef KDPAPP_H
#define KDPAPP_H

#include "kdpio.h"

/* Pre-/Post-/CPU-processing function provided by Kneron */

int kdp_cpu_nearest_upsample(int cpu_op, struct kdp_image_s *image_p);
int kdp_cpu_zero_upsample(int cpu_op, struct kdp_image_s *image_p);

int kdp_pre_face_recognition(int model_id, struct kdp_image_s *image_p);
int kdp_pre_face_recognition_mask(int model_id, struct kdp_image_s *image_p);
int kdp_preproc_fr_mask(int model_id, struct kdp_image_s *image_p);

int kdp_post_face_detection(int model_id, struct kdp_image_s *image_p);
int kdp_post_face_recognition_mask(int model_id, struct kdp_image_s *image_p);
int kdp_post_yolo(int model_id, struct kdp_image_s *image_p);
int kdp_post_imagenet_classification(int model_id, struct kdp_image_s *image_p);

int post_fcos_det(int model_id, struct kdp_image_s *image_p);
int post_classifier(int model_id, struct kdp_image_s *image_p);
int post_ssd_face_detection(int model_id, struct kdp_image_s *image_p);
int post_face_landmark_onet_5p(int model_id, struct kdp_image_s *image_p);
int post_age_gender(int model_id, struct kdp_image_s *image_p);
int post_nir_liveness(int model_id, struct kdp_image_s *image_p);
int post_ssd_object_detection(int model_id, struct kdp_image_s *image_p);
int post_yolov5(int model_id, struct kdp_image_s *image_p);
int post_licenseplate_ocr(int model_id, struct kdp_image_s *image_p);
int post_licenseplate_ocr_no_maxpool(int model_id, struct kdp_image_s *image_p);
int post_licenseplate_ocr_no_maxpool_optimized(int model_id, struct kdp_image_s *image_p);
int post_yolov3_optimized(int model_id, struct kdp_image_s *image_p);
int post_yolov5_optimized(int model_id, struct kdp_image_s *image_p);

#endif
