#ifndef UTILS_H
#define UTILS_H

#define MIN(a,b)                (((a)<(b))?(a):(b))
#define MAX(a,b)                (((a)>(b))?(a):(b))
#define ABS(a)                  (((a)>=0)?(a):(-(a)))
#define FLOOR(val)              ((int)(val) - ((int)(val) > val))
#define ROUND(x)                ((x)>=0?(int)((x)+0.5):(int)((x)-0.5))

/* Exported macro ------------------------------------------------------------*/
#ifdef  USE_FULL_ASSERT

/**
  * @brief  The assert_param macro is used for function's parameters check.
  * @param  expr: If expr is false, it calls assert_failed function
  *   which reports the name of the source file and the source
  *   line number of the call that failed.
  *   If expr is true, it returns no value.
  * @retval None
  */
#define assert_param(expr) ((expr) ? (void)0 : assert_failed((uint8_t *)__FILE__, __LINE__))
/* Exported functions ------------------------------------------------------- */
void assert_failed(uint8_t* file, uint32_t line);
#else
#define assert_param(expr) ((void)0)
#endif /* USE_FULL_ASSERT */

int constrain_int(int a, int min, int max);
float max_item_f(float* arr, int size);
float find_median_positive_short(short int *input, int size);
short find_min_positive_n(short* input, int size);

#endif

