#ifndef __BOARD_H__
#define __BOARD_H__

/* Common definitions for all boards with KL520 */

#define YES                         1
#define NO                          0

#define SENSOR_ID_HMX2056           0
#define SENSOR_ID_OV9286            1
#define SENSOR_ID_HMXRICA           2
#define SENSOR_ID_GC2145            3
#define SENSOR_ID_SC132GS           4
#define SENSOR_ID_MAX               5
#define SENSOR_ID_EXTERN            0xFE
#define SENSOR_ID_NONE              0xFF

#define IMGSRC_IN_PORT_NONE         0
#define IMGSRC_IN_PORT_MIPI         1
#define IMGSRC_IN_PORT_DPI          2  //DVP port
#define IMGSRC_IN_PORT_UVC          3

#define RES_640_480                 0
#define RES_480_640                 1
#define RES_480_272                 2
#define RES_272_480                 3

#define IMAGE_FORMAT_RGB565         0
#define IMAGE_FORMAT_RAW10          1
#define IMAGE_FORMAT_RAW8           2
#define IMAGE_FORMAT_YCBCR          3

#define IMAGE_TYPE_RGB              0
#define IMAGE_TYPE_IR               1

#define DISPLAY_DEVICE_LCDC         0
#define DISPLAY_DEVICE_LCM          1

#define PANEL_MZT_480X272           1
#define PANEL_ST7789_240X320        2

#define SENSOR_RES_RGB              RES_640_480
#define SENSOR_RES_NIR              RES_480_640
#define IMGSRC_FORMAT_RGB           IMAGE_FORMAT_RGB565
#define IMGSRC_FORMAT_NIR           IMAGE_FORMAT_RAW8

#define CFG_AI_3D_LIVENESS_IN_NONE  0
#define CFG_AI_3D_LIVENESS_IN_SCPU  1
#define CFG_AI_3D_LIVENESS_IN_NCPU  2

/* Specific definitions for each board */
#ifndef BOARD_DVP_EXAMPLE
#define SYS_CAMERA_CORE_NAME        "sys_camera_core"

#define SENSOR_HMX2056              1
#define SENSOR_HMXRICA_RAW8         2

#define YES                         1
#define NO                          0

/* PRE-definition for board configuration */
#define V2K_ENABLE_HMX2056          1
#define V2K_ENABLE_OV9286           2
#define V2K_ENABLE_HMX2056_OV9286   3
#define V2K_ENABLE_HMXRICA          4
#define V2K_ENABLE_GC2145           5
#define V2K_ENABLE_SC132GS          6
#define V2K_ENABLE_GC2145_SC132GS   7
#define V2K_ENABLE_SC132GS_GC2145   8

#define V2K_ENABLE_TYPE             NO

/* 520 EVB board configuration */
#define I2C_0_ENABLE                NO
#define I2C_1_ENABLE                NO
#define I2C_2_ENABLE                NO
#define I2C_3_ENABLE                NO

#define CAM_ID_MAX                  2
#define IMGSRC_NUM                  CAM_ID_MAX

#define MIPI_CAM_RGB                0
#define MIPI_CAM_NIR                1

/* i2c platform data */
struct i2c_platform_data {
    unsigned long bus_speed;
};

/* lcdc platform data */

enum lcd_img_input_fmt {
    lcd_img_input_fmt_rgb565 = 0,
    lcd_img_input_fmt_rgb555,
    lcd_img_input_fmt_rgb444,
    lcd_img_input_fmt_rgb24,
    lcd_img_input_fmt_ycbcr422,
    lcd_img_input_fmt_ycbcr420,
    lcd_img_input_fmt_palette_8,
    lcd_img_input_fmt_palette_4,
    lcd_img_input_fmt_palette_2,
    lcd_img_input_fmt_palette_1,
};

struct fb_platform_data {
    unsigned long input_fmt; // refer to enum lcd_img_input_fmt definition
    unsigned short xres;
    unsigned short yres; 
};
#else
#include "board_kl520_dvp_example.h"
#endif

// #ifdef BOARD_96
// #include "board_kl520_96.h"
// #include "board_cfg_96.h"
// #elif BOARD_DVP_EXAMPLE
// #include "board_kl520_dvp_example.h"
// #else
// #include "board_kl520_evb.h"
// #endif
// #ifdef KDP_UVC
// #include "board_uvc.h"
// #endif
#endif // __BOARD_KDP520_H__
