/**
 * @file        hico_simulator.h
 * @brief       macros and data structure for hico inference simulation
 * @version     0.1
 * @date        2021-07-02
 *
 * @copyright   Copyright (c) 2021 Kneron Inc. All rights reserved.
 */

#pragma once

#define JOB_ID_THIS_IS_IMAGE 2000      // job ID to tell host SW taht this is an image
#define JOB_ID_THIS_IS_INF_RESULT 2001 // job ID to tell host SW that this is an inference result
#define JOB_ID_LOAD_IMAGE 2002         // job ID to tell FW that this customized command attends to load an image to FW memory

#define IMAGE_WIDTH 640
#define IMAGE_HEIGHT 640
#define TOTAL_IMAGE_NUM 30

typedef struct
{
    /* header stamp is necessary for data transfer between host and device */
    kp_inference_header_stamp_t header_stamp;
    uint32_t index; // image index to sync with FW
} __attribute__((aligned(4))) load_image_command_t;
